package org.jpos.util;

import java.util.Hashtable;
import java.util.Iterator;

import org.jpos.iso.*;

/**
 * $Revision: 23416 $
 * $Date: 2007-03-14 00:14:09 +0000 (Wed, 14 Mar 2007) $
 * $Author: nsmith $
 */
class ISOMsgDeepCopier {

    private final ISOComponentDeepCopier componentCopier;

    ISOMsgDeepCopier(ISOComponentDeepCopier componentCopier) {
        this.componentCopier = componentCopier;
    }
    
    public ISOMsg doDeepCopy(ISOMsg msg) {
        try {
            ISOMsg newMsg = new ISOMsg();
            if (msg.isInner()) {
                newMsg.setFieldNumber(((Integer) msg.getKey()).intValue());
            }
            Hashtable children = msg.getChildren();
            Iterator keysIterator = children.keySet().iterator();
            while (keysIterator.hasNext()) {
                newMsg.set(componentCopier.doDeepCopy((ISOComponent) children.get(keysIterator.next())));
            }
            return newMsg;
        } catch (ISOException e) {
            throw new RuntimeException(e.getMessage());
        }
    }

}

